Package com.google.android.exoplayer2.extractor.mp3

## Class Mp3Extractor

- java.lang.Object
- - com.google.android.exoplayer2.extractor.mp3.Mp3Extractor

- All Implemented Interfaces:
    `Extractor`

      public final class Mp3Extractor
      extends Object
      implements Extractor

  Extracts data from the MP3 container format.

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Class | Description
    --- | --- | ---
    `static interface` | `Mp3Extractor.Flags` | Flags controlling the behavior of the extractor.

    - ### Nested classes/interfaces inherited from interface com.google.android.exoplayer2.extractor.Extractor

      `Extractor.ReadResult`

  - ### Field Summary

    Fields
    Modifier and Type | Field | Description
    --- | --- | ---
    `static ExtractorsFactory` | `FACTORY` | Factory for `Mp3Extractor` instances.
    `static int` | `FLAG_DISABLE_ID3_METADATA` | Flag to disable parsing of ID3 metadata.
    `static int` | `FLAG_ENABLE_CONSTANT_BITRATE_SEEKING` | Flag to force enable seeking using a constant bitrate assumption in cases where seeking would otherwise not be possible.
    `static int` | `FLAG_ENABLE_INDEX_SEEKING` | Flag to force index seeking, in which a time-to-byte mapping is built as the file is read.

    - ### Fields inherited from interface com.google.android.exoplayer2.extractor.Extractor

      `RESULT_CONTINUE, RESULT_END_OF_INPUT, RESULT_SEEK`

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `Mp3Extractor()` |
    `Mp3Extractor​(int flags)` |
    `Mp3Extractor​(int flags, long forcedFirstSampleTimestampUs)` |

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `void` | `disableSeeking()` | Disables the extractor from being able to seek through the media.
    `void` | `init​(ExtractorOutput output)` | Initializes the extractor with an `ExtractorOutput`.
    `int` | `read​(ExtractorInput input, PositionHolder seekPosition)` | Extracts data read from a provided `ExtractorInput`.
    `void` | `release()` | Releases all kept resources.
    `void` | `seek​(long position, long timeUs)` | Notifies the extractor that a seek has occurred.
    `boolean` | `sniff​(ExtractorInput input)` | Returns whether this extractor can extract samples from the `ExtractorInput`, which must provide data from the start of the stream.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### FACTORY

          public static final ExtractorsFactory FACTORY

      Factory for `Mp3Extractor` instances.

    - #### FLAG_ENABLE_CONSTANT_BITRATE_SEEKING

          public static final int FLAG_ENABLE_CONSTANT_BITRATE_SEEKING

      Flag to force enable seeking using a constant bitrate assumption in cases where seeking would otherwise not be possible.

      This flag is ignored if `FLAG_ENABLE_INDEX_SEEKING` is set.

      See Also:
        Constant Field Values

    - #### FLAG_ENABLE_INDEX_SEEKING

          public static final int FLAG_ENABLE_INDEX_SEEKING

      Flag to force index seeking, in which a time-to-byte mapping is built as the file is read.

      This seeker may require to scan a significant portion of the file to compute a seek point. Therefore, it should only be used if one of the following is true:

      - The file is small.
      - The bitrate is variable (or it's unknown whether it's variable) and the file does not provide precise enough seeking metadata.
      See Also:
        Constant Field Values

    - #### FLAG_DISABLE_ID3_METADATA

          public static final int FLAG_DISABLE_ID3_METADATA

      Flag to disable parsing of ID3 metadata. Can be set to save memory if ID3 metadata is not required.
      See Also:
        Constant Field Values

  - ### Constructor Detail

    - #### Mp3Extractor

          public Mp3Extractor()

    - #### Mp3Extractor

          public Mp3Extractor​(@Flags
                              int flags)

      Parameters:
        `flags` - Flags that control the extractor's behavior.

    - #### Mp3Extractor

          public Mp3Extractor​(@Flags
                              int flags,
                              long forcedFirstSampleTimestampUs)

      Parameters:
        `flags` - Flags that control the extractor's behavior.
        `forcedFirstSampleTimestampUs` - A timestamp to force for the first sample, or `C.TIME_UNSET` if forcing is not required.

  - ### Method Detail

    - #### sniff

          public boolean sniff​(ExtractorInput input)
                        throws IOException

      Description copied from interface: `Extractor`
      Returns whether this extractor can extract samples from the `ExtractorInput`, which must provide data from the start of the stream.

      If `true` is returned, the `input`'s reading position may have been modified. Otherwise, only its peek position may have been modified.

      Specified by:
        `sniff` in interface `Extractor`
      Parameters:
        `input` - The `ExtractorInput` from which data should be peeked/read.
      Returns:
        Whether this extractor can read the provided input.
      Throws:
        `IOException` - If an error occurred reading from the input.

    - #### init

          public void init​(ExtractorOutput output)

      Description copied from interface: `Extractor`
      Initializes the extractor with an `ExtractorOutput`. Called at most once.
      Specified by:
        `init` in interface `Extractor`
      Parameters:
        `output` - An `ExtractorOutput` to receive extracted data.

    - #### seek

          public void seek​(long position,
                           long timeUs)

      Description copied from interface: `Extractor`
      Notifies the extractor that a seek has occurred.

      Following a call to this method, the `ExtractorInput` passed to the next invocation of `Extractor.read(ExtractorInput, PositionHolder)` is required to provide data starting from `position` in the stream. Valid random access positions are the start of the stream and positions that can be obtained from any `SeekMap` passed to the `ExtractorOutput`.

      Specified by:
        `seek` in interface `Extractor`
      Parameters:
        `position` - The byte offset in the stream from which data will be provided.
        `timeUs` - The seek time in microseconds.

    - #### release

          public void release()

      Description copied from interface: `Extractor`
      Releases all kept resources.
      Specified by:
        `release` in interface `Extractor`

    - #### read

          public int read​(ExtractorInput input,
                          PositionHolder seekPosition)
                   throws IOException

      Description copied from interface: `Extractor`
      Extracts data read from a provided `ExtractorInput`. Must not be called before `Extractor.init(ExtractorOutput)`.

      A single call to this method will block until some progress has been made, but will not block for longer than this. Hence each call will consume only a small amount of input data.

      In the common case, `Extractor.RESULT_CONTINUE` is returned to indicate that the `ExtractorInput` passed to the next read is required to provide data continuing from the position in the stream reached by the returning call. If the extractor requires data to be provided from a different position, then that position is set in `seekPosition` and `Extractor.RESULT_SEEK` is returned. If the extractor reached the end of the data provided by the `ExtractorInput`, then `Extractor.RESULT_END_OF_INPUT` is returned.

      When this method throws an `IOException`, extraction may continue by providing an `ExtractorInput` with an unchanged `read position` to a subsequent call to this method.

      Specified by:
        `read` in interface `Extractor`
      Parameters:
        `input` - The `ExtractorInput` from which data should be read.
        `seekPosition` - If `Extractor.RESULT_SEEK` is returned, this holder is updated to hold the position of the required data.
      Returns:
        One of the `RESULT_` values defined in this interface.
      Throws:
        `IOException` - If an error occurred reading from or parsing the input.

    - #### disableSeeking

          public void disableSeeking()

      Disables the extractor from being able to seek through the media.

      Please note that this needs to be called before `read(com.google.android.exoplayer2.extractor.ExtractorInput, com.google.android.exoplayer2.extractor.PositionHolder)`.